From: Fabián Ezequiel Gallina <[email-masked]>
Date: Wed, 13 Feb 2013 21:31:32 -0300

The current behavior follows pretty much what emacs-lisp-mode does for 
lisp movement, so I won't agree calling it weird, It's just a matter of 
taste. If setting the `forward-sexp-function' to nil fits your needs 
then feel free to do so. I'll add documentation in the header explaining 
how to disable such behavior.

The paren thing at end of defun Daniel found is a known cornercase, 
which unfortunately I can't fix because `blink-matching-open' needs 
`python-nav-forward-sexp' to behave this way to work correctly.

Also notice this is not a whimsical feature, it was in fact a feature 
request[0] by another user. And I honestly find it pretty cool overall.

[0] https://github.com/fgallina/python.el/issues/106

Regards,
Fabián.